首页 > 代码库 > Leetcode: Guess Number Higher or Lower II
Leetcode: Guess Number Higher or Lower II
e are playing the Guess Game. The game is as follows: I pick a number from 1 to n. You have to guess which number I picked. Every time you guess wrong, I‘ll tell you whether the number I picked is higher or lower. However, when you guess a particular number x, and you guess wrong, you pay $x. You win the game when you guess the number I picked. Example: n = 10, I pick 8. First round: You guess 5, I tell you that it‘s higher. You pay $5. Second round: You guess 7, I tell you that it‘s higher. You pay $7. Third round: You guess 9, I tell you that it‘s lower. You pay $9. Game over. 8 is the number I picked. You end up paying $5 + $7 + $9 = $21. Given a particular n ≥ 1, find out how much money you need to have to guarantee a win.
The best strategy to play the game is to minimize the maximum loss you could possibly face.
Definition of dp[i][j]
: minimum number of money to guarantee win for subproblem [i, j]
.
Target: dp[1][n]
Corner case: dp[i][i] = 0
(because the only element must be correct)
Equation: we can choose k (i<=k<=j)
as our guess, and pay price k
. After our guess, the problem is divided into two subproblems. Notice we do not need to pay the money for both subproblems. We only need to pay the worst case (because the system will tell us which side we should go) to guarantee win. So dp[i][j] = min (i<=k<=j) { k + max(dp[i][k-1], dp[k+1][j]) }
1 public class Solution { 2 public int getMoneyAmount(int n) { 3 int[][] dp = new int[n+2][n+2]; 4 for (int len=1; len<=n-1; len++) { 5 for (int from=1, to=from+len; to<=n; from++, to++) { 6 dp[from][to] = Integer.MAX_VALUE; 7 for (int k=from; k<=to; k++) { 8 dp[from][to] = Math.min(dp[from][to], k+Math.max(dp[from][k-1], dp[k+1][to])); 9 } 10 } 11 } 12 return dp[1][n]; 13 } 14 }
Leetcode: Guess Number Higher or Lower II
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。